'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Channel = require('ipfs-pubsub-1on1');

var Logger = require('logplease');
var logger = Logger.create("exchange-heads", { color: Logger.Colors.Yellow });
Logger.setLogLevel('ERROR');

var getHeadsForDatabase = function getHeadsForDatabase(store) {
  return store && store._oplog ? store._oplog.heads : [];
};

var exchangeHeads = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ipfs, address, peer, getStore, getDirectConnection, onMessage, onChannelCreated) {
    var _handleMessage, channel, heads;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _handleMessage = function _handleMessage(message) {
              var msg = JSON.parse(message.data);
              var address = msg.address,
                  heads = msg.heads;

              onMessage(address, heads);
            };

            channel = getDirectConnection(peer);

            if (channel) {
              _context.next = 16;
              break;
            }

            _context.prev = 3;

            logger.debug('Create a channel to ' + peer);
            _context.next = 7;
            return Channel.open(ipfs, peer);

          case 7:
            channel = _context.sent;

            channel.on('message', _handleMessage);
            logger.debug('Channel created to ' + peer);
            onChannelCreated(channel);
            _context.next = 16;
            break;

          case 13:
            _context.prev = 13;
            _context.t0 = _context['catch'](3);

            logger.error(_context.t0);

          case 16:
            _context.next = 18;
            return channel.connect();

          case 18:
            logger.debug('Connected to ' + peer);

            // Send the heads if we have any
            heads = getHeadsForDatabase(getStore(address));

            logger.debug('Send latest heads of \'' + address + '\':\n', (0, _stringify2.default)(heads.map(function (e) {
              return e.hash;
            }), null, 2));

            if (!heads) {
              _context.next = 24;
              break;
            }

            _context.next = 24;
            return channel.send((0, _stringify2.default)({ address: address, heads: heads }));

          case 24:
            return _context.abrupt('return', channel);

          case 25:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[3, 13]]);
  }));

  return function exchangeHeads(_x, _x2, _x3, _x4, _x5, _x6, _x7) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exchangeHeads;